function SHA1(_1){
function rotate_left(n,s){
var t4=(n<<s)|(n>>>(32-s));
return t4;
};
function lsb_hex(_5){
var _6="";
var i;
var vh;
var vl;
for(i=0;i<=6;i+=2){
vh=(_5>>>(i*4+4))&15;
vl=(_5>>>(i*4))&15;
_6+=vh.toString(16)+vl.toString(16);
}
return _6;
};
function cvt_hex(_a){
var _b="";
var i;
var v;
for(i=7;i>=0;i--){
v=(_a>>>(i*4))&15;
_b+=v.toString(16);
}
return _b;
};
function Utf8Encode(_e){
_e=_e.replace(/\r\n/g,"\n");
var _f="";
for(var n=0;n<_e.length;n++){
var c=_e.charCodeAt(n);
if(c<128){
_f+=String.fromCharCode(c);
}else{
if((c>127)&&(c<2048)){
_f+=String.fromCharCode((c>>6)|192);
_f+=String.fromCharCode((c&63)|128);
}else{
_f+=String.fromCharCode((c>>12)|224);
_f+=String.fromCharCode(((c>>6)&63)|128);
_f+=String.fromCharCode((c&63)|128);
}
}
}
return _f;
};
var _12;
var i,j;
var W=new Array(80);
var H0=1732584193;
var H1=4023233417;
var H2=2562383102;
var H3=271733878;
var H4=3285377520;
var A,B,C,D,E;
var _20;
_1=Utf8Encode(_1);
var _21=_1.length;
var _22=new Array();
for(i=0;i<_21-3;i+=4){
j=_1.charCodeAt(i)<<24|_1.charCodeAt(i+1)<<16|_1.charCodeAt(i+2)<<8|_1.charCodeAt(i+3);
_22.push(j);
}
switch(_21%4){
case 0:
i=2147483648;
break;
case 1:
i=_1.charCodeAt(_21-1)<<24|8388608;
break;
case 2:
i=_1.charCodeAt(_21-2)<<24|_1.charCodeAt(_21-1)<<16|32768;
break;
case 3:
i=_1.charCodeAt(_21-3)<<24|_1.charCodeAt(_21-2)<<16|_1.charCodeAt(_21-1)<<8|128;
break;
}
_22.push(i);
while((_22.length%16)!=14){
_22.push(0);
}
_22.push(_21>>>29);
_22.push((_21<<3)&4294967295);
for(_12=0;_12<_22.length;_12+=16){
for(i=0;i<16;i++){
W[i]=_22[_12+i];
}
for(i=16;i<=79;i++){
W[i]=rotate_left(W[i-3]^W[i-8]^W[i-14]^W[i-16],1);
}
A=H0;
B=H1;
C=H2;
D=H3;
E=H4;
for(i=0;i<=19;i++){
_20=(rotate_left(A,5)+((B&C)|(~B&D))+E+W[i]+1518500249)&4294967295;
E=D;
D=C;
C=rotate_left(B,30);
B=A;
A=_20;
}
for(i=20;i<=39;i++){
_20=(rotate_left(A,5)+(B^C^D)+E+W[i]+1859775393)&4294967295;
E=D;
D=C;
C=rotate_left(B,30);
B=A;
A=_20;
}
for(i=40;i<=59;i++){
_20=(rotate_left(A,5)+((B&C)|(B&D)|(C&D))+E+W[i]+2400959708)&4294967295;
E=D;
D=C;
C=rotate_left(B,30);
B=A;
A=_20;
}
for(i=60;i<=79;i++){
_20=(rotate_left(A,5)+(B^C^D)+E+W[i]+3395469782)&4294967295;
E=D;
D=C;
C=rotate_left(B,30);
B=A;
A=_20;
}
H0=(H0+A)&4294967295;
H1=(H1+B)&4294967295;
H2=(H2+C)&4294967295;
H3=(H3+D)&4294967295;
H4=(H4+E)&4294967295;
}
var _20=cvt_hex(H0)+cvt_hex(H1)+cvt_hex(H2)+cvt_hex(H3)+cvt_hex(H4);
return _20.toLowerCase();
};
