var WrtHelper={isTouchEnabledDevice:function(){
if(WrtHelper._isTouchEnabledDevice===undefined){
if(this.getSysInfo5()){
var _1={Entity:"Features",Key:"Pen"};
var _2=this.getSysInfo5().ISysInfo.GetInfo(_1);
WrtHelper._isTouchEnabledDevice=(_2&&_2.ReturnValue)?_2.ReturnValue.Status:false;
}else{
var _3=Math.max(this.screenHeight(),this.screenWidth());
var _4=Math.min(this.screenHeight(),this.screenWidth());
WrtHelper._isTouchEnabledDevice=((_3===800&&_4===480)||(_4===360&&_3===640));
}
if(WrtHelper.log.isInfoEnabled()){
WrtHelper.log.info("Device pen supported: "+WrtHelper._isTouchEnabledDevice);
}
}
return WrtHelper._isTouchEnabledDevice;
},isWrt5OrLater:function(){
if(WrtHelper._isWrt5===undefined){
var _5=parseFloat(this._getSdkVersion());
WrtHelper._isWrt5=(!isNaN(_5)&&_5>=5);
}
return WrtHelper._isWrt5;
},getSysInfo5:function(){
if(WrtHelper._sysInfo5===undefined){
if(this.isWrt5OrLater()){
try{
WrtHelper._sysInfo5=device.getServiceObject("Service.SysInfo","ISysInfo");
}
catch(err){
WrtHelper.log.warn("Unable to retrieve ISysInfo object.",err);
WrtHelper._sysInfo5=null;
}
}else{
WrtHelper._sysInfo5=null;
}
}
return WrtHelper._sysInfo5;
},isLargeScreen:function(){
if(this._isLargeScreen===undefined){
var _6=Math.max(this.screenHeight(),this.screenWidth());
this._isLargeScreen=_6>400;
if(WrtHelper.log.isInfoEnabled()){
WrtHelper.log.info("Is large screen: "+WrtHelper._isLargeScreen);
}
}
return this._isLargeScreen;
},isLandscape:function(){
return WrtHelper.screenHeight()<WrtHelper.screenWidth();
},screenHeight:function(){
return screen.height;
},screenWidth:function(){
return screen.width;
},getPhoneModel:function(){
if(!this._phoneModel){
this._setPhoneMetadata();
}
return this._phoneModel;
},getPhoneFirmvareVersion:function(){
if(!this._phoneFirmvareVersion){
this._setPhoneMetadata();
}
return this._phoneFirmvareVersion;
},_setPhoneMetadata:function(){
var _7=/^.+Series60\/[\d\.]+\s([\S]+)\/([\d\.]+)/gi;
var _8=_7.exec(WrtHelper.getUserAgent());
if(_8){
this._phoneFirmvareVersion=_8[2];
this._phoneModel=_8[1];
}else{
this._phoneFirmvareVersion="";
this._phoneModel="";
}
},getSysInfo:function(){
if(!WrtHelper._sysinfo){
var _9=document.createElement("div");
_9.style.position="absolute";
_9.style.top="-30px";
_9.innerHTML="<embed id='sysinfo' type='application/x-systeminfo-widget' hidden='yes'/>";
document.body.appendChild(_9);
WrtHelper._sysinfo=document.getElementById("sysinfo");
}
return WrtHelper._sysinfo;
},getUserAgent:function(){
return navigator.userAgent;
},_getSdkVersion:function(){
if(!this._sdkVersion){
var _a=WrtHelper.getUserAgent().match(/Series60\/([\d\.]+)/);
this._sdkVersion=(_a&&_a.length>1)?_a[1]:"unknown";
if(WrtHelper.log.isInfoEnabled()){
WrtHelper.log.info("SDK version: '"+WrtHelper._sdkVersion+"'");
}
}
return this._sdkVersion;
},log:Logger.getLogger("WrtHelper")};
