function AsyncJob(_1){
this.lastUpdateTime=0;
this.broker=_1;
this._operationInProgress=false;
this.onError=null;
this.onSuccess=null;
var _2=this;
this.broker.onSuccess=function(_3,_4){
_2.handleSuccessResponse(_3,_4);
};
this.broker.onError=function(_5){
_2.handleErrorResponse(_5);
};
};
AsyncJob.prototype.startAsync=function(_6,_7,_8){
this.progressHandler=_7;
if(this._operationInProgress){
this.showProgress();
AsyncJob.log.debug("Operation is already in progress.");
return;
}
var _9=new Date().getTime();
if(_8||this.lastUpdateTime+AsyncJob.INTERVAL<_9){
this.showProgress();
return this._brokerStartAsync(_6);
}
return true;
};
AsyncJob.prototype._brokerStartAsync=function(_a){
this._operationInProgress=true;
this._lastRequest=_a;
return this.broker.startAsync(_a);
};
AsyncJob.prototype.getBroker=function(){
return this.broker;
};
AsyncJob.prototype.cancel=function(){
this.showProgress(false);
this.broker.cancel();
};
AsyncJob.prototype.showProgress=function(_b){
if(this.progressHandler){
if(_b==null){
_b=true;
}
if(AsyncJob.log.isDebugEnabled()){
AsyncJob.log.debug("showProgress "+_b);
}
if(loader){
loader.show(_b);
}
if(!WrtHelper.isTouchEnabledDevice()&&this.progressHandler.setDimmedSoftMenu){
APUtils.queForExecution(this,function(){
this.progressHandler.setDimmedSoftMenu(_b);
});
}
if(_b&&this.progressHandler.isActive()){
APUtils.setStatusLabel(StringTable.qtn_downloading);
}
}
};
AsyncJob.prototype.setFilterFunction=function(_c){
this._filterCaching=_c;
};
AsyncJob.prototype.enableCache=function(){
this.handleSuccessResponse=function(_d,_e){
this.showProgress(false);
this._operationInProgress=false;
var _f;
if(!_e){
argTmp=this._filterCaching(_d);
this.lastUpdateTime=new Date().getTime();
_f={response:argTmp,lastUpdate:this.lastUpdateTime};
var _10=VerverApi.calculatePrefName(this.progressHandler,this._lastRequest);
var _11=JSON.stringify(_f);
Config.getPreferencesMap().tryPut(_10,_11);
latUpdateTime=(this.lastUpdateTime)?new Date():null;
if(_12){
_12.setTime(this.lastUpdateTime);
}
}else{
this.lastUpdateTime=_d.lastUpdate;
_f=_d;
}
if(this.onSuccess){
this.onSuccess.call(this,_f.response,_e);
}
if(this.progressHandler&&this.progressHandler.setLastUpdatedTime){
var _12=(this.lastUpdateTime)?new Date():null;
if(_12){
_12.setTime(this.lastUpdateTime);
}
this.progressHandler.setLastUpdatedTime(_12,_e);
}
};
this.handleErrorResponse=function(req){
this.showProgress(false);
this._operationInProgress=false;
if(req.getStatus()!=403){
var arg=Config.getPreferencesMap().get(VerverApi.calculatePrefName(this.progressHandler,this._lastRequest));
if(arg){
arg=JSON.parse(arg);
if(this.onSuccess){
this.broker.onSuccess(arg,true);
}
return;
}
}
if(this.onError){
this.onError.call(this,req);
}
if(this.progressHandler&&this.progressHandler.setLastUpdatedTime){
this.progressHandler.setLastUpdatedTime(new Exception(StringTable.qtn_connnection_error));
}
};
};
AsyncJob.prototype.handleSuccessResponse=function(arg){
this.showProgress(false);
this._operationInProgress=false;
this.lastUpdateTime=new Date().getTime();
_16=(this.lastUpdateTime)?new Date():null;
var _17=arg;
if(this._filterCaching){
arg=this._filterCaching(_17);
}
if(_16){
_16.setTime(this.lastUpdateTime);
}
if(this.onSuccess){
this.onSuccess.call(this,arg);
}
if(this.progressHandler&&this.progressHandler.setLastUpdatedTime){
var _16=(this.lastUpdateTime)?new Date():null;
if(_16){
_16.setTime(this.lastUpdateTime);
}
this.progressHandler.setLastUpdatedTime(_16);
}
};
AsyncJob.prototype.handleErrorResponse=function(req){
this.showProgress(false);
this._operationInProgress=false;
if(this.onError){
this.onError.call(this,req);
}
if(this.progressHandler&&this.progressHandler.setLastUpdatedTime){
this.progressHandler.setLastUpdatedTime(new Exception(StringTable.qtn_connnection_error));
}
};
AsyncJob.log=Logger.getLogger("AsyncJob");
AsyncJob.INTERVAL=300000;
