function RequestBroker(){
this.httpReq=null;
this.onSuccess=null;
this.onError=null;
this._body=null;
this._method="GET";
this._contentType=null;
};
RequestBroker.prototype.startAsync=function(_1){
this.url=_1;
this.httpReq=new XMLHttpRequest();
if(RequestBroker.log.isInfoEnabled()){
RequestBroker.log.info("Fetching data from "+_1);
}
var _2=this;
this.httpReq.onreadystatechange=function(){
_2.readyStateChanged();
};
this.canceled=false;
this.httpReq.open(this._method,_1,true);
if(this._contentType){
this.httpReq.setRequestHeader("Content-Type",this._contentType);
}
this.httpReq.send(this._body);
};
RequestBroker.prototype.setMethod=function(_3){
this._method=_3;
};
RequestBroker.prototype.setBody=function(_4){
this._body=_4;
};
RequestBroker.prototype.setContentType=function(_5){
this._contentType=_5;
};
RequestBroker.prototype.getMethod=function(){
return this._method;
};
RequestBroker.prototype.cancel=function(){
this.canceled=true;
try{
if(this.httpReq){
this.httpReq.abort();
this.httpReq.onreadystatechange=function(){
};
}
}
catch(ex){
RequestBroker.log.warn("cancel failed.",ex);
}
};
RequestBroker.prototype.getResponseText=function(){
return this.httpReq.responseText;
};
RequestBroker.prototype.getStatus=function(){
return this.httpReq.status;
};
RequestBroker.prototype.readyStateChanged=function(){
if(this.httpReq.readyState==4){
var _6=null;
try{
_6=this.httpReq.status;
}
catch(noStatusException){
RequestBroker.log.warn("No status specified in response.",noStatusException);
}
if(RequestBroker.log.isDebugEnabled()){
RequestBroker.log.debug("Got response with status "+_6+" "+this.httpReq.statusText);
}
if(this.canceled){
return;
}
var _7=this.httpReq;
if(_6>=200&&_6<300){
var _8=this.httpReq.responseText;
if(this.httpReq.responseXML==null&&_8!=null&&_8.toLowerCase().indexOf("meta http-equiv=\"refresh\"")!=-1){
this.startAsync(this.url);
return;
}
try{
this.onSuccess.call(this,this.httpReq);
}
catch(err){
RequestBroker.log.error("Processing response failed.",err);
}
}else{
this.onError.call(this,this);
}
if(this.httpReq==_7){
this.httpReq=null;
}
}
};
RequestBroker.log=Logger.getLogger("RequestBroker");
