function Stories(){
Stories.baseConstructor.call(this,"stories","content");
this.runTimerWhenPageIsActive(true);
this.hasReloadButton(true);
this._table=new Table(this,"stories_table");
};
Helper.extend(Stories,APScreenBase);
Stories.BackDescriptor=function(_1,_2){
this._parent=_1;
this._category=_2;
};
Stories.BackDescriptor.prototype={getCategory:function(){
return this._category;
},getParent:function(){
return this._parent;
}};
Stories.prototype.showStories=function(_3,_4,_5,_6,_7){
this._table.setIsVideo(_7);
this.setReportItem(_4);
if(_3===this){
this.setBackPage(new Stories.BackDescriptor(this._backPage,this._category));
}else{
this.setBackPage(_3);
}
if(!_4){
this._table.clear();
this._category=null;
this.hasSearchButton(false);
this.hasReloadButton(false);
this.parent.activate(this.id);
this._table.setSoftMenuOnShow();
return;
}
this._category=_4;
this._postalCode=(_4.isLocalNewsCategory())?Config.getPostalCode():null;
if(_5==null){
_5=function(_8){
var _9=this.parent.get("news_details");
_9.displayStory(this,_8);
};
}
this.hasSearchButton(!_4.isSearchCategory()&&!_7);
this.hasReloadButton(!_4.isSearchCategory());
this.parent.activate(this.id);
this._table.setSoftMenuOnShow();
if(_7){
this._table.setVideoHandler(_6);
}else{
this._table.setIsVideo(false);
}
this._table.setHandler(_5);
this._table.clear();
if(_3===this){
this.onTimerTick();
}
this._category.displayAd(this);
};
Stories.prototype.processBackButton=function(){
if(this._backPage&&!this._backPage.id){
this.showStories(this._backPage.getParent(),this._backPage.getCategory());
this.onTimerTick();
if(WrtHelper.isTouchEnabledDevice()){
this._searchButton.show(true);
this._reloadButton.show(true);
}else{
this._searchSoftMenu.setMyDimmed(false);
this._reloadSoftMenu.setMyDimmed(false);
}
}else{
Stories.base.processBackButton.call(this);
}
};
Stories.prototype.processSearchRequest=function(_a,_b){
_a.call(this,this._category);
if(WrtHelper.isTouchEnabledDevice()){
this._searchButton._toggle=false;
this._searchButton.setClassName("red",false);
this._searchButton.show(false);
this._reloadButton.show(false);
}else{
this._searchSoftMenu.setMyDimmed(true);
this._reloadSoftMenu.setMyDimmed(true);
}
};
Stories.prototype.isUpdateRequired=function(){
if(!this._category){
return;
}
this._contentListFunc=this._category.contentList;
var _c=this._category.getContentListLastUpdateTime();
var _d=Config.getRefreshRate();
if(this._forceRefresh||(_c&&_d&&_c.getTime()+_d*1000<new Date().getTime())){
this._forceRefresh=false;
this._contentListFunc=this._category.refresh;
return !this._category.isSearchCategory();
}
if(this._table.isEmpty()){
return true;
}
return false;
};
Stories.prototype.forceRefresh=function(){
this._forceRefresh=true;
};
Stories.prototype.onUpdate=function(){
this._table.clear();
this._contentListFunc.call(this._category,this,this.onContentListed,function(){
});
};
Stories.prototype.onContentListed=function(_e){
var _f=(this._category.isSearchCategory())?StringTable.qtn_search_results:this._category.getName();
this._table.addHeader(_f);
for(var i=0;i<_e.length;++i){
if(!_e[i].isVideo()||(_e[i].getLoVideoList().length>0||_e[i].getHiVideoList().length>0)){
this._table.addRow(_e[i]);
}
}
this.invalidate();
};
Stories.prototype.getTable=function(){
return this._table;
};
Stories.prototype.onActivated=function(){
if(this._category&&this._category.isLocalNewsCategory()){
var _11=Config.getPostalCode();
if(!_11){
Stories.base.onActivated.call(this);
this._closeBtns[0].onclicked();
}else{
if(this._postalCode!==_11){
this._postalCode=_11;
this._forceRefresh=true;
Stories.base.onActivated.call(this);
}else{
Stories.base.onActivated.call(this);
}
}
}else{
Stories.base.onActivated.call(this);
}
};
