function Cache(){
this.items={};
};
Cache.prototype.get=function(_1){
var ci=this.checkAndReturn(_1);
if(ci){
return ci.value;
}
return null;
};
Cache.prototype.put=function(_3,_4,_5){
var _6=_5>0?new Date().getTime()+_5*1000:-1;
var _7={value:_4,expiresAt:_6};
this._store(_3,_7);
};
Cache.prototype._store=function(_8,_9){
this.items[_8]=_9;
};
Cache.prototype._retrieve=function(_a,_b){
return this.items[_a];
};
Cache.prototype.clear=function(){
this._clear();
};
Cache.prototype._clear=function(){
this.items={};
};
Cache.prototype.checkAndReturn=function(_c,_d){
var _e=this._retrieve(_c);
if(!_e){
return null;
}
if(_e.expiresAt<0){
return _e;
}
var _f=new Date().getTime();
if(_f>=_e.expiresAt){
if(Cache.log.isDebugEnabled()){
Cache.log.debug("Item '"+_c+"' expired in cache");
}
this.remove(_c);
return null;
}else{
return _e;
}
};
Cache.prototype.remove=function(_10){
if(Cache.log.isDebugEnabled()){
Cache.log.debug("Removing '"+_10+"' from cache.");
}
delete this.items[_10];
};
Cache.log=Logger.getLogger("Cache");
Cache.PERMANENT=-1;
function PreferencesCache(_11){
var _12=new Cache();
var _13=new PreferencesMap(_11);
_12._store=function(_14,_15){
var _16=_15.expiresAt;
var _17=new Date();
_17.setTime(_16);
_15.expiresAt=_16.toString();
var _18=JSON.stringify(_15);
if(!_13.tryPut(_14,_18)){
Cache.log.warn("Cache full");
}else{
if(Cache.log.isDebugEnabled()){
Cache.log.debug("Storing "+_14+" into preferences cache. Expires: "+_17+", data: "+_18+"'");
Debug.assert(_14.indexOf(" ")<0,"Key: "+_14+" must not contain spaces");
}
}
};
_12._retrieve=function(_19,_1a){
var key=_19;
var _1c=_13.get(key);
if(!_1c){
Cache.log.debug("Entry "+_19+" not found in cache.");
return null;
}
var ret=JSON.parse(_1c);
ret.expiresAt=parseInt(ret.expiresAt);
if(Cache.log.isDebugEnabled()){
var _1e=new Date();
Cache.log.debug("Retrieved "+_19+" from preferences cache. Expires at: "+_1e+", Value: "+_1c);
}
return ret;
};
_12.remove=function(_1f){
Cache.log.debug("Removed "+_1f+" from preferences cache.");
_13.remove(_1f);
},_12._clear=function(){
_13.clear();
};
_12.setMemoryLimit=function(_20){
_13.prefLimit=_20;
};
return _12;
};
