var JSON={stringify:function(_1,_2){
var rv="";
if(_1==null){
return "null";
}
switch(_1.constructor){
case Array:
rv+="[";
for(var i=0;i<_1.length;++i){
if(i>0){
rv+=",";
}
rv+=JSON.stringify(_1[i]);
}
rv+="]";
break;
case String:
_1=_1.replace(/\\/g,"\\\\");
_1=_1.replace(/"/g,"\\\"");
_1=_1.replace(/\r/g,"\\r");
_1=_1.replace(/\n/g,"\\n");
rv+="\""+_1+"\"";
break;
case Number:
if(!_2&&JSON.log.isInfoEnabled()&&_1>(2^23)){
JSON.log.error(_1+" is bigger than 2^23 and should not be converted to JSON due to a 3.2 bug. Convert number to strings");
}
rv+=_1.toString();
break;
case Boolean:
rv+=_1?"true":"false";
break;
default:
var _5="{";
for(var _6 in _1){
if(_5.length>1){
_5+=",";
}
_5+="\""+_6+"\":"+JSON.stringify(_1[_6]);
}
rv+=_5+"}";
break;
}
return rv;
},parse:function(_7){
function assert(_8,_9){
if(!_8){
throw new SyntaxError(_9);
}
};
function isEspaced(_a,_b){
var _c=0;
for(var i=_b-1;i>=0&&_a.charAt(i)==="\\";i--,_c++){
}
return _c%2===0;
};
function escape(_e){
_e=_e.replace(JSON.UNICODE_ESCAPES,function(a){
return String.fromCharCode(parseInt(a.slice(2),16));
});
for(var i=0;i<JSON.ESCAPES.length;i+=2){
_e=_e.replace(JSON.ESCAPES[i+1],JSON.ESCAPES[i]);
}
return _e;
};
var _11={};
var _12={};
var _13=null;
var _14=[];
var _15=[];
var _16=[JSON.START];
var _17=[];
var len=_7.length;
var _19=false;
for(var i=0;i<len;){
if(_19){
i++;
if(i>=len){
break;
}
}
var ch=_7.charAt(i);
if(ch===" "){
continue;
}
var _1c=_16[_16.length-1];
_19=true;
switch(_1c){
case JSON.START:
_16.pop();
if(ch==="{"){
_16.push(JSON.OBJECT);
}else{
if(ch==="["){
_16.push(JSON.ARRAY);
}else{
throw new Error("JSON should start with '[' or '{' and not with '"+ch+"'");
}
}
_19=false;
break;
case JSON.OBJECT:
if(ch==="{"){
_17.push({});
_14.push(_12);
}else{
if(ch=="}"){
var _1d=_14.pop();
if(_1d!==_12){
var _1e=_17.pop();
var obj=_17[_17.length-1];
obj[_1d]=_1e;
}
_16.pop();
break;
}else{
if(ch===","){
var _1d=_14.pop();
var _1e=_17.pop();
var obj=_17[_17.length-1];
obj[_1d]=_1e;
_16.push(JSON.MEMBER);
}else{
var _1d=_14.pop();
_19=false;
_16.push(JSON.MEMBER);
}
}
}
break;
case JSON.ARRAY:
if(ch==="["){
if(_17[_17.length-1]===_11){
_17.pop();
_16.push(JSON.ARRAY);
}
_17.push([]);
_17.push(_11);
}else{
if(ch==="]"){
var _1e=_17.pop();
if(_1e!==_11){
_17[_17.length-1].push(_1e);
}
_16.pop();
}else{
if(ch===","){
var _1e=_17.pop();
_17[_17.length-1].push(_1e);
_16.push(JSON.VALUE);
}else{
var _20=_17.pop();
_19=false;
_16.push(JSON.VALUE);
}
}
}
break;
case JSON.MEMBER:
var _1d;
if(ch!=="\""){
var idx=_7.indexOf(":",i+1);
_1d=_7.substring(i,idx);
i+=_1d.length;
_1d=_1d.replace(/ /g,"");
}else{
var idx=_7.indexOf("\"",i+1);
_1d=_7.substring(i+1,idx);
i+=_1d.length+1;
}
_14.push(_1d);
var _22=_7.indexOf(":",i);
i=_22;
_16.pop();
_16.push(JSON.VALUE);
break;
case JSON.VALUE:
var _1e=null;
if(ch==="["){
_16.pop();
_16.push(JSON.ARRAY);
_19=false;
continue;
}else{
if(ch==="{"){
_16.pop();
_16.push(JSON.OBJECT);
_19=false;
continue;
}else{
if(ch==="\""){
var _23=i;
do{
_23=_7.indexOf("\"",_23+1);
}while(!isEspaced(_7,_23));
_1e=_7.substring(i+1,_23);
if(_1e.indexOf("\\")>=0){
var foo="({\"a\" : \""+_1e+"\"})";
_1e=eval(foo).a;
}
i=_23;
}else{
if((ch>="0"&&ch<="9")||(ch==="-")||(ch==".")){
var end=i+1;
for(ch=_7[end];end<_7.length&&((ch>="0"&&ch<="9")||ch===".");ch=_7[++end]){
}
_1e=_7.substring(i,end);
i=end-1;
}else{
if(ch==="t"&&_7.indexOf("true",i)===i){
_1e=true;
i+=3;
}else{
if(ch==="f"&&_7.indexOf("false",i)===i){
_1e=false;
i+=4;
}else{
if(ch==="n"&&_7.indexOf("null",i)===i){
_1e=null;
i+=3;
}else{
throw new SyntaxError("Cannot parse value: "+_7.substr(i,i+5)+"...");
}
}
}
}
}
}
}
_17.push(_1e);
_16.pop();
break;
default:
throw new SyntaxError("Unknown text: "+_7);
break;
}
}
var ret=_17.pop();
return ret;
},log:Logger.getLogger("JSON")};
JSON.START=0;
JSON.OBJECT=1;
JSON.ARRAY=2;
JSON.MEMBER=3;
JSON.VALUE=4;
JSON.MEMBER_REG_EX=/\"(.*)?\"/;
JSON.DIGIT_REG_EX=/\d+(\.\d*)?/;
JSON.UNICODE_ESCAPES=/\\u[0-9a-f]{4,4}/g;
JSON.ESCAPES=[/'\\\\'/g,"/","\b",/\\b/g,"\t",/\\t/g,"\n",/\\n/g,"\f",/\\f/g,"\r",/\\r/g,"\"",/\\"/g];
JSON.UNICODE_ESCAPABLE=/[\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
JSON.NEEDS_ESCAPE_REGEX=/\\/g;
