function ImageLoader(){
this._images=new Array();
this._img=null;
this._imgData=null;
};
ImageLoader.prototype.addImage=function(_1){
_1.container=$(_1.container);
this._images.push(_1);
};
ImageLoader.prototype.load=function(){
this._images.reverse();
this._load();
};
ImageLoader.prototype._load=function(){
clearTimeout(this._loadTimerId);
if(this._images.length>0){
this._imgData=this._images.pop();
var _2=this;
this._img=$(document.createElement("img"));
this._img.onload=function(){
_2._onImageLoaded();
};
this._img.onerror=function(){
_2._onImageError();
};
this._loadTimerId=setTimeout(function(){
_2._onImageLoaded();
},ImageLoader.TIMEOUT);
this._img.src=this._imgData.src;
}
};
ImageLoader.prototype.cancel=function(){
this._images=new Array();
this._imgData=null;
};
ImageLoader.prototype.isDone=function(){
return (this._images.length<=0);
};
ImageLoader.prototype._onImageLoaded=function(){
if(this._imgData){
if(this._imgData.container){
this._img.onload=null;
this._img.onerror=null;
if(this._imgData.className){
this._img.className=this._imgData.className;
}
this._imgData.container.removeChildren();
this._imgData.container.appendChild(this._img);
}
this._imgData=null;
}
this._load();
};
ImageLoader.prototype._onImageError=function(){
if(this._imgData){
if(this._imgData.container){
this._img.onload=null;
this._img.onerror=null;
this._img.src=ImageLoader.ERROR_IMAGE;
if(this._imgData.className){
this._img.className=this._imgData.className;
}
this._imgData.container.removeChildren();
this._imgData.container.appendChild(this._img);
}
this._imgData=null;
}
this._load();
};
ImageLoader.ERROR_IMAGE="images/image_error_gray.png";
ImageLoader.TIMEOUT=5*1000;
