var Direction={};
Direction.DOWN=0;
Direction.UP=1;
Direction.LEFT=2;
Direction.RIGHT=3;
var UIUtils={};
UIUtils.FOCUSABLE_ITEM_CLASS="n";
UIUtils.FOCUSABLE_REG_EX=new RegExp("(^|\\s)"+UIUtils.FOCUSABLE_ITEM_CLASS+"(\\s|$)");
UIUtils.getFocusableItems=function(_1){
var _2=Logger.getLogger("UIUtils");
var _3=_1.all?_1.all:_1.getElementsByTagName("*");
var _4=[];
var _5;
var _6=_3.length;
for(var i=0;i<_6;i++){
_5=_3[i];
if((_5.style.display=="none"||_5.style.visibility=="hidden"||_5.className.indexOf("hidden")>=0)){
continue;
}
if((_5.offsetWidth===undefined&&_5.offsetHeight===undefined)){
continue;
}
if(UIUtils.FOCUSABLE_REG_EX.test(_5.className)){
_4.push(_5);
}
}
return _4;
};
UIUtils.getNextElementForEvent=function(_8,_9,_a){
var _b=UIUtils.getElementBounds(_a);
var _c=UIUtils.getElementBounds(_9);
switch(_8.keyNum){
case Keyboard.KEY_LEFT:
return UIUtils.getFirstElementLeft(_a,_b,_9,_c);
case Keyboard.KEY_RIGHT:
return UIUtils.getFirstElementRight(_a,_b,_9,_c);
case Keyboard.KEY_UP:
return UIUtils.getFirstElementAbove(_a,_b,_9,_c);
case Keyboard.KEY_DOWN:
return UIUtils.getFirstElementBelow(_a,_b,_9,_c);
}
return null;
};
UIUtils.getFirstElementAbove=function(_d,_e,_f,_10){
var pos=_e;
var _12=_10;
var _13,_14,ret=null,cx=pos.x+Math.ceil(pos.width/2),cy=pos.y;
for(var i=0;i<_f.length;i++){
var _19=_f[i];
if(_19===_d){
continue;
}
var _1a=_12[i];
if(_1a.y>=pos.y){
continue;
}
var ny=_1a.y+_1a.height;
var dy=pos.y-ny;
var dx=Math.abs(pos.x-_1a.x);
if(!ret||(_13>dy)||(_13===dy&&dx<_14)){
ret=_19;
_13=dy;
_14=dx;
}
}
return ret;
};
UIUtils.getFirstElementBelow=function(_1e,_1f,_20,_21){
var pos=_1f;
var _23=_21;
var ret=null;
var _25,_26;
var cx=pos.x+Math.ceil(pos.width/2),cy=pos.y+pos.height;
for(var i=0;i<_20.length;i++){
var _2a=_20[i];
if(_2a===_1e){
continue;
}
var _2b=_23[i];
if(_2b.y<=pos.y){
continue;
}
var dx=Math.abs(_2b.x-pos.x);
var dy=_2b.y-pos.y;
if(ret===null||_25>dy||(_25===dy&&_26>dx)){
ret=_2a;
_25=dy;
_26=dx;
}
}
return ret;
};
UIUtils.getFirstElementLeft=function(_2e,_2f,_30,_31){
var pos=_2f;
var _33=_31;
var _34=-1;
var ret=null;
var _36=0,_37=0;
var _38=false;
var cx=pos.x,cy=pos.y+Math.ceil(pos.height/2);
for(var i=0;i<_30.length;i++){
var _3c=_30[i];
if(_3c===_2e){
continue;
}
var _3d=_33[i];
if(_3d.x>=pos.x){
continue;
}
var _3e=((pos.y-5)<_3d.y)&&((pos.y+5)>_3d.y);
if(_38&&!_3e){
continue;
}else{
if(_38){
var _3f=pos.x-_3d.x;
if(_3f<_36){
ret=_3c;
_36=_3f;
}
}else{
if(_3e){
ret=_3c;
_38=true;
_36=pos.x-_3d.x;
}else{
var nx=_3d.x,ny=_3d.y+Math.floor(_3d.height/2);
var d=Math.sqrt(((cx-nx)*(cx-nx))+((cy-ny)*(cy-ny)));
if(!ret||d<_34){
ret=_3c;
_34=d;
}
}
}
}
}
return ret;
};
UIUtils.getFirstElementRight=function(_43,_44,_45,_46){
var pos=_44;
var _48=_46;
var _49=0,_4a=0;
var _4b=false;
var ret=null;
var cx=pos.x+pos.width,cy=pos.y+pos.height/2;
for(var i=0;i<_45.length;i++){
var _50=_45[i];
if(_50===_43){
continue;
}
var _51=_48[i];
if(_51.x<pos.x+pos.width-5){
continue;
}
var _52=((pos.y-5)<_51.y)&&((pos.y+5)>_51.y);
if(_4b&&!_52){
continue;
}else{
if(_4b){
var _53=_51.x-pos.x;
if(_53<_49){
ret=_50;
_49=_53;
}
}else{
if(_52){
ret=_50;
_4b=true;
_49=_51.x-pos.x;
}else{
var nx=_51.x,ny=_51.y+_51.height/2;
var d=Math.sqrt(((cx-nx)*(cx-nx))+((cy-ny)*(cy-ny)));
if(!ret||d<minD){
ret=_50;
minD=d;
}
if(!ret||d<minD){
ret=_50;
minD=d;
}
}
}
}
}
return ret;
};
UIUtils.getElementBounds=function(_57){
var ret;
var _59;
if(_57.constructor===Array){
ret=new Array(_57.length);
_59=_57;
}else{
_59=[_57];
}
var _5a;
var _5b;
for(var j=0;j<_59.length;j++){
var obj=_59[j];
if(j===0&&obj.offsetParent){
_5a=obj.offsetParent;
_5b=UIUtils.getElementBounds(_5a);
}
var _5e=0,_5f=0,_60=obj.offsetWidth,_61=obj.offsetHeight;
foo=obj;
while(foo){
if(foo===_5a){
_5e+=_5b.x;
_5f+=_5b.y;
break;
}
if(foo.nodeName==="TR"){
var _62=foo.childNodes;
var _63=false;
var _64=0;
var _65=0;
var _66=0;
for(var i=0;i<_62.length;i++){
var n=_62[i];
if(n.tagName!=="TD"){
continue;
}
_64=!_63?n.offsetLeft:Math.min(n.offsetLeft,_64);
_65=!_63?n.offsetTop:Math.min(n.offsetTop,_65);
_66=Math.max(_66,n.offsetHeight);
_63=true;
}
_5e+=_64;
_5f+=_65;
if(foo===obj){
_61=_66;
}
}else{
_5e+=foo.offsetLeft;
_5f+=foo.offsetTop;
}
foo=foo.offsetParent;
}
var _69={x:_5e,y:_5f,width:_60,height:_61};
if(ret){
ret[j]=_69;
}else{
ret=_69;
}
}
return ret;
};
UIUtils.getScrollableParent=function(_6a){
var _6b=_6a.parentNode;
while(_6b){
if(_6b.tagName!=="SPAN"){
if(_6b.clientHeight<_6b.scrollHeight){
return _6b;
}
if(_6b.scrollTop!=null){
_6b.scrollTop=0;
}
}
_6b=_6b.parentNode;
}
return null;
};
UIUtils.startScrolling=function(_6c){
var _6d=new Effects.textScroller();
_6d.start(_6c);
return _6d;
};
