function XmlRequestBroker(){
this.broker=new RequestBroker();
var _1=this;
this.broker.onSuccess=function(_2){
var _3=_2.responseXML;
if(!_3){
try{
XmlRequestBroker.log.warn("Expecting xml document but responseXML is not set.");
_3=new DOMParser().parseFromString(_2.responseText,"text/xml");
}
catch(err){
XmlRequestBroker.log.error("Parsing xml text failed.",err);
_3=null;
}
}
if(!_3){
_1.onError.call(_1,500);
}else{
var _4=XmlRequestBroker._parseXml(_3.firstChild);
_1.onSuccess(_4);
_4=null;
}
};
this.broker.onError=function(_5){
_1.onError.call(_1,_5);
};
this.onSuccess=null;
this.onError=null;
};
XmlRequestBroker._parseString=function(_6){
try{
var _7=new DOMParser().parseFromString(_6,"text/xml");
return XmlRequestBroker._parseXml(_7.firstChild);
}
catch(err){
XmlRequestBroker.log.error("Parsing '"+_6+"' failed.",err);
}
return null;
};
XmlRequestBroker.prototype.startAsync=function(_8){
this.broker.startAsync(_8);
};
XmlRequestBroker.prototype.cancel=function(){
this.broker.cancel();
};
XmlRequestBroker.prototype.setMethod=function(_9){
this.broker.setMethod(_9);
};
XmlRequestBroker.prototype.getMethod=function(){
return this.broker.getMethod();
};
XmlRequestBroker.prototype.setBody=function(_a){
this.broker.setBody(_a);
};
XmlRequestBroker.prototype.setContentType=function(_b){
this.broker.setContentType(_b);
};
XmlRequestBroker._parseXml=function(_c){
if(_c==null){
return {};
}
if(_c.nodeType==Node.TEXT_NODE){
if(_c.nextSibling==null||_c.nextSibling.nodeType==Node.TEXT_NODE){
var _d="";
while(_c!=null){
if(_c.nodeType==Node.TEXT_NODE){
_d+=new String(_c.nodeValue);
}else{
XmlRequestBroker.log.warn("Text child nodes shouldn't contain other siblings than text: "+_c.nodeType);
break;
}
_c=_c.nextSibling;
}
if(_c==null){
return {leaf:true,value:_d};
}
}
}
if(_c.nodeType==Node.CDATA_SECTION_NODE){
return {value:_c.nodeValue};
}
var _e={};
while(_c!=null){
if(_c.nodeType==Node.ELEMENT_NODE){
var _f=_c.nodeName.replace(/:/g,"");
var rv=XmlRequestBroker._parseXml(_c.firstChild);
if(rv&&rv.leaf){
if(XmlRequestBroker.log.isDebugEnabled()){
XmlRequestBroker.log.debug(_f+"="+rv.value);
}
_e[_f]=rv.value;
}else{
rv.__attributes__={};
for(var i=0;i<_c.attributes.length;++i){
var _12=_c.attributes.item(i);
rv.__attributes__[new String(_12.nodeName.toLowerCase())]=new String(_12.nodeValue);
}
rv.getAttribute=function(_13){
return this.__attributes__[_13];
};
if(_e[_f]==null){
_e[_f]=[rv];
}else{
_e[_f].push(rv);
}
}
}
_c=_c.nextSibling;
}
return _e;
};
XmlRequestBroker.log=Logger.getLogger("XmlRequestBroker");
