function APScreenBase(id,_2,_3){
APScreenBase.baseConstructor.call(this,id,_2);
this.setBackButtonId("bar_close_btn");
if(!_3){
_3=false;
}
this._rememberPage=_3;
this._softMenus=new HashTable();
this._about=new About(this);
};
Helper.extend(APScreenBase,Container);
APScreenBase.prototype.hasSearchButton=function(_4){
this._hasSearchButton=_4;
};
APScreenBase.prototype.hasReloadButton=function(_5){
this._hasReloadButton=_5;
};
APScreenBase.prototype.onActivated=function(){
APScreenBase.base.onActivated.call(this);
var _6=this;
if(this._rememberPage){
Config.setStartPage(this.id);
}
if(WrtHelper.isTouchEnabledDevice()){
this._optionsButton=$("bottom_options");
Events(this._optionsButton).setAction(function(){
_6._callOptions();
});
this._closeBtns=[];
for(var i=0;i<this._closeButtonIds.length;++i){
this._closeBtns.push(this._setBackButton(this._closeButtonIds[i]));
}
var _8=$("bottom_search");
_8.show(this._hasSearchButton);
if(this._hasSearchButton){
var _9=new SearchPopup(this);
this._searchButton=_8;
this._searchButton._toggle=false;
this._searchButton.setClassName("red",false);
Events(this._searchButton).setAction(function(){
this._toggle=!this._toggle;
this.setClassName("red",this._toggle);
_9.show(this._toggle);
});
}
this._weather=$("weather_today");
Events(this._weather).setAction(function(){
_6._callWeather();
});
var _a=$("bottom_bar_reload_btn");
_a.show(this._hasReloadButton);
if(this._hasReloadButton){
this._reloadButton=_a;
Events(this._reloadButton).setAction(function(){
_6._callRefresh();
});
}
this._top_logo=$("top_logo");
Events(this._top_logo).setAction(function(){
_6.onActivatedAboutPop();
});
}else{
APUtils.queForExecution(this,this.onActivatedSoftMenu,true);
}
this.displayLastUpdateTime();
if(this._runTimerWhenPageIsActive){
this.startTimer();
}else{
this._updateCommonItems();
}
if(this._reportItem&&this._allowReporting!=null){
this._reportItem.reporting(null);
if(!this._allowReporting){
this._allowReporting=null;
}
}
};
APScreenBase.prototype.onActivatedAboutPop=function(){
this._about.show(true);
};
APScreenBase.prototype.onDeactivated=function(){
if(WrtHelper.isTouchEnabledDevice()){
this._optionsButton=null;
this._closeBtns=null;
this._searchButtonOnSearchPopup=null;
if(this._searchButton&&this._searchButton._toggle){
this._searchButton.action();
}
this._searchButton=null;
this._weather=null;
this._reloadButton=null;
this._top_logo=null;
}else{
window.menu.clear();
window.menu.onShow=null;
delete this._softMenus;
this._softMenus=null;
this._softMenus=new HashTable();
}
this.stopTimer();
APScreenBase.base.onDeactivated.call(this);
};
APScreenBase.prototype.addSoftMenuItem=function(_b,id){
var _d=new MenuItem(_b,id);
var _e={};
_e.menuItem=_d;
_e._myDimmed=false;
_e.setMyDimmed=function(_f){
this._myDimmed=_f;
this.menuItem.setDimmed(_f);
};
this._softMenus.put(id,_e);
return _e;
};
APScreenBase.prototype.setDimmedSoftMenu=function(_10){
if(WrtHelper.isTouchEnabledDevice()){
return;
}
if(!_10){
_10=false;
}
var _11=this._softMenus.iterator();
while(_11.hasNext()){
var el=_11.value();
if(_10){
el.menuItem.setDimmed(true);
}else{
el.menuItem.setDimmed(el._myDimmed);
}
}
if(_10){
window.menu.setRightSoftkeyLabel("",null);
window.menu.onShow=null;
}else{
this._setRightSoftKey();
window.menu.onShow=this._onShowSoftMenu;
}
};
APScreenBase.prototype.setOnShowSoftMenu=function(_13){
this._onShowSoftMenu=_13;
window.menu.onShow=this._onShowSoftMenu;
};
APScreenBase.prototype.setReportItem=function(_14,_15){
this._reportItem=_14;
if(_15===undefined){
_15=true;
}
this._allowReporting=_15;
};
APScreenBase.prototype.getMenuItemById=function(id){
return this._softMenus.get(id);
};
APScreenBase.prototype.onActivatedSoftMenu=function(){
var _17=this;
var _18=window.menu;
var _19=this.addSoftMenuItem(StringTable.qtn_user_goto,APScreenBase.MENU);
_18.append(_19.menuItem);
var _1a=this.addSoftMenuItem(StringTable.qtn_front_page,APScreenBase.FRONTPAGE);
_1a.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17._showMenu("frontpage");
});
};
_19.menuItem.append(_1a.menuItem);
var _1b=this.addSoftMenuItem(StringTable.qtn_category_plural,APScreenBase.CATEGORIES);
_1b.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17._showMenu("categories");
});
};
_19.menuItem.append(_1b.menuItem);
var _1c=this.addSoftMenuItem(StringTable.qtn_photo,APScreenBase.PHOTO);
_1c.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17._showMenu("photo_categories");
});
};
_19.menuItem.append(_1c.menuItem);
var _1d=this.addSoftMenuItem(StringTable.qtn_video,APScreenBase.VIDEO);
_1d.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17._showMenu("video_categories");
});
};
_19.menuItem.append(_1d.menuItem);
var _1e=this.addSoftMenuItem(StringTable.qtn_weather,APScreenBase.WEATHER);
_1e.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17._callWeather();
});
};
_19.menuItem.append(_1e.menuItem);
var _1f=this.addSoftMenuItem(StringTable.qtn_option_plural,APScreenBase.OPTIONS);
_1f.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17._callOptions();
});
};
_19.menuItem.append(_1f.menuItem);
var _20=this.addSoftMenuItem(StringTable.qtn_about_title,APScreenBase.ABOUT);
_20.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17.onActivatedAboutPop();
});
};
_19.menuItem.append(_20.menuItem);
if(this._hasSearchButton){
this._searchSoftMenu=this.addSoftMenuItem(StringTable.qtn_search,APScreenBase.SEARCH);
this._searchToggle=false;
var _21=new SearchPopup(this);
this._searchSoftMenu.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_21.show(true);
});
};
_18.append(this._searchSoftMenu.menuItem);
}
if(this._hasReloadButton){
this._reloadSoftMenu=this.addSoftMenuItem(StringTable.qtn_refresh,APScreenBase.REFRESH);
this._reloadSoftMenu.menuItem.onSelect=function(){
APUtils.queForExecution(_17,function(){
_17._callRefresh();
});
};
_18.append(this._reloadSoftMenu.menuItem);
}
this._setRightSoftKey();
};
APScreenBase.prototype._processSearchRequest=function(_22){
this.processSearchRequest(function(_23){
var _24=this;
var _25=this.parent.get("stories");
_23.searchContent(_25,_22,function(_26){
_25.showStories(_24,_26);
},function(){
_25.showStories(_24);
});
},function(){
});
};
APScreenBase.prototype._setBackButton=function(id){
var _28=$(id);
_28.innerHTML=(this._backPage)?StringTable.qtn_back:StringTable.qtn_exit;
var _29=this;
Events(_28).setAction(function(){
_29.processBackButton();
});
return _28;
};
APScreenBase.prototype.processBackButton=function(){
if(this._backPage){
this.parent.activate(this._backPage.id);
}else{
window.close();
}
};
APScreenBase.prototype.setLastUpdatedTime=function(_2a,_2b){
this._lastUpdatedTime=_2a;
this._fromCache=_2b;
this.displayLastUpdateTime();
};
APScreenBase.prototype.displayLastUpdateTime=function(){
if(this.isActive()){
APUtils.setStatusLabel(this._lastUpdatedTime,this._fromCache);
}
};
APScreenBase.prototype.runTimerWhenPageIsActive=function(run){
this._runTimerWhenPageIsActive=run;
};
APScreenBase.prototype.setBackPage=function(_2d){
this._backPage=_2d;
};
APScreenBase.prototype.setBackButtonId=function(ids){
if(ids.constructor!==Array){
ids=[ids];
}
this._closeButtonIds=ids;
};
APScreenBase.prototype.stopTimer=function(){
if(this._updateTimerId!=null){
clearInterval(this._updateTimerId);
this._updateTimerId=null;
}
};
APScreenBase.prototype.startTimer=function(){
var _2f=this;
var _30=0;
var _31=30;
APUtils.queForExecution(this,function(){
this.onTimerTick.call(this,_30);
});
this._updateTimerId=setInterval(function(){
_30+=_31;
_2f.onTimerTick.call(_2f,_30);
},_31*1000);
};
APScreenBase.prototype.isTimerRunning=function(){
return (this._updateTimerId!=null);
};
APScreenBase.prototype.setNewsFlashPlaceholder=function(id){
this._newsFlashPlaceholder=$(id);
};
APScreenBase.prototype.isUpdateRequired=function(){
return false;
};
APScreenBase.prototype.onUpdate=function(){
};
APScreenBase.prototype._updateCommonItems=function(_33){
_33=_33||0;
APUtils.updateDateInStatusBar();
if(this._newsFlashPlaceholder&&_33%500===0){
APHiearchy.getCategory("Newsflash",this,function(_34){
var _35=this;
_34._stories=null;
_34.contentList(null,function(_36){
_35._onNewsFlashReceived.call(_35,_36);
},_35._onNewsFlashReceivedError);
},this._onNewsFlashReceivedError);
}
if(_33%(AccuWeatherApi.UPDATE_MINUTES/1000)===0){
var _37=Config.getPostalCode();
if(_37===""){
$("weathertext").innerHTML="&nbsp;";
$("location").innerHTML="&nbsp;";
$("temperature").innerHTML="&nbsp;";
}else{
AccuWeatherApi.weatherData(Config.getPostalCode(),function(xml){
var _39=$("temperature");
if(_39.childNodes.length==0){
_39.appendChild(document.createElement("img"));
_39.appendChild(document.createElement("span"));
}
_39.childNodes[0].src="./images/weatherIcons/"+new String(xml.adc_database[0].currentconditions[0].weathericon)+".png";
_39.childNodes[1].innerHTML=new String(APUtils.getTemperature(xml.adc_database[0].currentconditions[0].temperature));
$("weathertext").innerHTML=new String(xml.adc_database[0].currentconditions[0].weathertext);
$("location").innerHTML=new String(xml.adc_database[0].local[0].city+", "+xml.adc_database[0].local[0].state);
},function(){
});
}
this._postCode=Config.getPostalCode();
}
};
APScreenBase.prototype.onTimerTick=function(_3a){
if(this.isUpdateRequired()){
this.onUpdate();
}
this._updateCommonItems(_3a);
};
APScreenBase.prototype._onNewsFlashReceived=function(_3b){
if(_3b.length>0&&_3b[0].getDescription().length>0){
this._newsFlashPlaceholder.innerHTML=_3b[0].getDescription();
this._newsFlashPlaceholder.show(true);
}else{
this._newsFlashPlaceholder.show(false);
}
};
APScreenBase.prototype._onNewsFlashReceivedError=function(){
if(this._newsFlashPlaceholder){
this._newsFlashPlaceholder.show(false);
}
};
APScreenBase.prototype._callOptions=function(){
var _3c=this.parent.get("config");
_3c.display(this);
};
APScreenBase.prototype._callWeather=function(){
if(Config.getPostalCode()!==""){
uiManager.get("weather_forecast").display(this);
}
};
APScreenBase.prototype._callRefresh=function(){
this.forceRefresh();
this.isUpdateRequired();
this.onUpdate();
};
APScreenBase.prototype._showMenu=function(id){
this.parent.activate(id);
this.parent.showMenu(false);
};
APScreenBase.prototype._setRightSoftKey=function(){
var _3e=this;
var _3f=window.menu;
if(this._backPage){
_3f.setRightSoftkeyLabel(StringTable.qtn_back,function(){
APUtils.queForExecution(_3e,function(){
_3e.processBackButton();
});
});
}else{
_3f.setRightSoftkeyLabel("",null);
}
};
APScreenBase.MENU=1001;
APScreenBase.ACTIONS=1002;
APScreenBase.OPTIONS=1003;
APScreenBase.SEARCH=1004;
APScreenBase.WEATHER=1005;
APScreenBase.REFRESH=1006;
APScreenBase.FRONTPAGE=1007;
APScreenBase.CATEGORIES=1008;
APScreenBase.PHOTO=1009;
APScreenBase.VIDEO=1010;
APScreenBase.ABOUT=1011;
