function Configuration(){
Configuration.baseConstructor.call(this,"config","content");
this._conifComponent=new ConfigComponent(this);
this._conifComponent.addItem($("config_table_title"));
this._conifComponent.addItem($("config_table_temp"));
this._conifComponent.addItem($("config_table_cat"));
this._conifComponent.addItem($("config_table_twitter"));
this._conifComponent.addItem($("config_table_delicious"));
this._conifComponent.addItem($("config_table_user"));
this._catComp=new CategoryComponent(this,$("config_category_container"));
var _1=this;
this._popup=new ChangeLocationPopup(this,function(_2,_3){
APHiearchy.getCategory(_1._catComp.getCategory(),this,function(_4){
_1._localnews=_4.getLocalNewsCategory();
_1.isCategoryLocalNews(_1._localnews?true:false);
if(_3){
_1.locateForNorthAmerica(_2);
}else{
_1.locateForOtherRegions(_2);
}
},function(){
});
},function(){
APHiearchy.getCategory(_1._catComp.getCategory(),this,function(_5){
_1._localnews=_5.getLocalNewsCategory();
_1.isCategoryLocalNews(_1._localnews?true:false);
_1.findCurrentLocation();
},function(){
});
});
Events($("config_change_location")).setAction(function(){
var _6=_1._catComp.getCategory()=="North America";
_1._popup.display(_6?_1._post_code:_1._city+", "+_1._state,_6);
});
this._temp=new GroupBox("config_temp_radio_list");
this._temp.addItem($("config_F"),"F");
this._temp.addItem($("config_C"),"C");
this._sex=new GroupBox("config_user_sex");
this._sex.addItem($("config_user_male"),"male");
this._sex.addItem($("config_user_female"),"female");
var _7=$("config_user_age");
for(var x=0;x<StringTable.age.length;x++){
var _9=document.createElement("option");
_9.text=StringTable.age[x];
_9.value=StringTable.age[x];
_7.appendChild(_9);
}
};
Helper.extend(Configuration,APScreenBase);
Configuration.prototype.onActivatedSoftMenu=function(){
Configuration.base.onActivatedSoftMenu.call(this);
var _a=this;
var _b=window.menu;
var _c=this.addSoftMenuItem(StringTable.qtn_cancel,Configuration.CANCEL);
_c.menuItem.onSelect=function(){
APUtils.queForExecution(_a,function(){
_a.processBackButton();
});
};
_b.append(_c.menuItem);
};
Configuration.prototype._setRightSoftKey=function(){
var _d=window.menu;
var _e=this;
_d.setRightSoftkeyLabel(StringTable.qtn_save,function(){
APUtils.queForExecution(_e,function(){
_e.saveConfiguration();
});
});
};
Configuration.prototype.display=function(_f){
this._parent=_f;
this.parent.activate(this.id);
};
Configuration.prototype.onActivated=function(){
this.setBackPage(this._parent);
this._conifComponent.showDefault();
Configuration.base.onActivated.call(this);
if(WrtHelper.isLargeScreen()){
this.setButtonsForTouch();
}
this.initForm();
};
Configuration.prototype.setButtonsForTouch=function(){
for(var i=0;i<this._closeBtns.length;++i){
this._closeBtns[i].innerHTML=StringTable.qtn_cancel;
}
this._optionsButton.innerHTML=StringTable.qtn_save;
var _11=this;
Events(this._optionsButton).setAction(function(){
_11.saveConfiguration();
});
};
Configuration.prototype.onDeactivated=function(_12){
if(WrtHelper.isLargeScreen()){
this._optionsButton.innerHTML=StringTable.qtn_option_plural;
}
Configuration.base.onDeactivated.call(this);
};
Configuration.prototype.saveConfiguration=function(){
if(this.lookingLocationStatus()==true){
alert(StringTable.qtn_still_looking);
return;
}
Config.setSex(this._sex.getItem().value);
Config.setAge($("config_user_age").value);
Config.setEmail($("config_user_email").value);
Config.setTemp(this._temp.getItem().value);
Config.setPostalCode(this._post_code);
Config.setTwitterPassword($("config_twitter_password").value);
Config.setTwitterUsername($("config_twitter_username").value);
Config.setDeliciousPassword($("config_delicious_password").value);
Config.setDeliciousUsername($("config_delicious_username").value);
Config.setCity(this._city);
Config.setState(this._state);
Config.setWeatherStatus(this[Configuration.WEATHER].status);
Config.setLocalNewsStatus(this[Configuration.LOCALNEWS].status);
var _13=Config.getCategories()?Config.getCategories():["undefined"];
if(TopLevelCategory.getName()!=this._catComp.getCategory().toString()||_13.toString()!=this._catComp.getSubCategory().toString()){
TopLevelCategory.setName(this._catComp.getCategory());
Config.setCategories(this._catComp.getSubCategory());
var _14=this.parent.get("frontpage");
_14.forceRefresh();
_14=this.parent.get("categories");
_14.forceRefresh();
}
Config.submitPreference();
this.parent.activate(this._parent.id);
};
Configuration.prototype.lookingLocationStatus=function(){
if(this[Configuration.WEATHER].showImg==(Configuration.WEATHER+Configuration.STATUS_LOAD)||(this.isCategoryLocalNews()&&this[Configuration.LOCALNEWS].showImg==(Configuration.LOCALNEWS+Configuration.STATUS_LOAD))){
return true;
}
return false;
};
Configuration.prototype.findCurrentLocation=function(){
var _15=this;
this.cleanLocation();
this.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_LOAD);
this.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_LOAD);
LocationApi.getLocation(this,function(_16,_17){
AccuWeatherApi.weatherDataCordination(_17,_16,function(xml){
_15.setWeatherStatus(xml);
},function(){
_15.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_INCORRECT);
});
VerverApi.queryLocation(null,_16,_17,function(xml){
_15.SetLocalNewsStatus(xml);
},function(){
_15.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_INCORRECT);
});
},function(msg){
_15.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_INCORRECT);
_15.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_INCORRECT);
});
};
Configuration.prototype.SetLocalNewsStatus=function(xml){
if(xml.QueryLocationResponse){
var el=xml.QueryLocationResponse[0].LocationQuery[0].postal_code[0];
this.setLocation(el.getAttribute("city"),el.getAttribute("state"),el.getAttribute("postal_code"));
}else{
if(xml.city&&xml.state&&xml.postCode){
this.setLocation(xml.city,xml.state,xml.postCode);
}else{
this.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_INCORRECT);
return;
}
}
this.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_CORRECT);
};
Configuration.prototype.prepareLocationPlace=function(){
this.cleanLocation();
if(location.length===0){
this.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_INCORRECT);
this.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_INCORRECT);
this._post_code="";
return;
}
this.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_LOAD);
this.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_LOAD);
};
Configuration.prototype.searchWeather=function(_1d){
var _1e=this;
AccuWeatherApi.weatherData(_1d,function(xml){
_1e.setWeatherStatus(xml);
},function(){
_1e.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_INCORRECT);
},true);
};
Configuration.prototype.locateForOtherRegions=function(_20){
this.prepareLocationPlace();
var _21=this;
AccuWeatherApi.findLocation(_20,function(xml){
try{
var _23=xml.adc_database[0].citylist[0].location[0].getAttribute("location");
_21.searchWeather(_23);
}
catch(e){
_21.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_INCORRECT);
}
},function(){
_21.setLocationStatus(Configuration.WEATHER,Configuration.STATUS_INCORRECT);
});
};
Configuration.prototype.locateForNorthAmerica=function(_24){
this.prepareLocationPlace();
this.searchWeather(_24);
if(this._localnews==null){
return;
}
var _25=this;
VerverApi.contentList(null,function(xml){
_25.SetLocalNewsStatus(xml);
},function(res){
_25.setLocationStatus(Configuration.LOCALNEWS,Configuration.STATUS_INCORRECT);
},this._localnews._category.getId(),10,_24,true);
};
Configuration.prototype.setWeatherStatus=function(xml){
var res=xml.adc_database[0].failure==="Location does not exist"?false:true;
if(res){
var reg=new RegExp("^.+&.*=(.*)$");
var _2b=reg.exec(xml.adc_database[0].currentconditions[0].url.toString());
this.setLocation(xml.adc_database[0].local[0].city,xml.adc_database[0].local[0].state,_2b[1]);
_2b=null;
reg=null;
}
res=res?Configuration.STATUS_CORRECT:Configuration.STATUS_INCORRECT;
this.setLocationStatus(Configuration.WEATHER,res);
};
Configuration.prototype.isCategoryLocalNews=function(_2c){
if(_2c!==undefined){
$(Configuration.LOCALNEWS).show(_2c);
this._isLocNews=_2c;
}
return this._isLocNews;
};
Configuration.prototype.setLocationStatus=function(id,_2e){
if(!this[id]){
this[id]={};
}
this[id].status=Configuration.STATUS_CORRECT===_2e?true:false;
if(this[id].showImg){
$(this[id].showImg).setClassName("hiddenImg",true);
}
this[id].showImg=id+_2e;
$(this[id].showImg).setClassName("hiddenImg",false);
};
Configuration.prototype.cleanLocation=function(){
$("cofig_new_location").innerHTML="&nbsp;";
this._post_code="";
this._city="";
this._state="";
};
Configuration.prototype.setLocation=function(_2f,_30,_31){
var _32=$("cofig_new_location");
if(_32.innerHTML.length===1||_32.innerHTML==="&nbsp;"){
var _33=_2f+", "+_30;
_32.innerHTML=_33;
this._post_code=_31;
this._city=_2f;
this._state=_30;
}
};
Configuration.prototype.setCategory=function(_34){
$("config_categories_label").innerHTML=Utils.format(StringTable.qtn_region_plural,this._catComp.getCategory());
this.parent.activate(this.id);
};
Configuration.prototype.initForm=function(){
var _35=this;
this._temp.selectedValue(Config.getTemp());
this._sex.selectedValue(Config.getSex());
this.cleanLocation();
this.setLocation(Config.getCity(),Config.getState(),Config.getPostalCode());
this._catComp.setStartCategory(TopLevelCategory.getName());
this._catComp.setStartSubCategory(Config.getCategories());
this._catComp.fillContainerCategory();
var _36=Config.getWeatherStatus();
var _37=Config.getLocalNewsStatus();
APHiearchy.getCategory(TopLevelCategory.getName(),this,function(_38){
_35._localnews=_38.getLocalNewsCategory();
_35.isCategoryLocalNews(_35._localnews?true:false);
},function(){
});
this.setLocationStatus(Configuration.WEATHER,_36==true?Configuration.STATUS_CORRECT:Configuration.STATUS_INCORRECT);
this.setLocationStatus(Configuration.LOCALNEWS,_37==true?Configuration.STATUS_CORRECT:Configuration.STATUS_INCORRECT);
$("config_twitter_password").value=Config.getTwitterPassword();
$("config_twitter_username").value=Config.getTwitterUsername();
$("config_delicious_password").value=Config.getDeliciousPassword();
$("config_delicious_username").value=Config.getDeliciousUsername();
$("config_user_email").value=Config.getEmail();
$("config_user_age").value=Config.getAge();
this.invalidate();
};
Configuration.WEATHER="config_weather";
Configuration.LOCALNEWS="config_local_news";
Configuration.STATUS_INCORRECT="_incorrect";
Configuration.STATUS_CORRECT="_correct";
Configuration.STATUS_LOAD="_load";
Configuration.STATUS_NONE="";
Configuration.CANCEL=3001;
