function SlideShowPhotoView(){
SlideShowPhotoView.baseConstructor.call(this,"photo_view");
this.setBackButtonId(["photo_view_back","photo_view_back_landscape"]);
if(WrtHelper.isLargeScreen()){
this.setButtonsForTouch();
}else{
this.setButtonsForNonTouch();
}
};
Helper.extend(SlideShowPhotoView,APScreenBase);
SlideShowPhotoView.prototype._processKeyEvent=function(_1){
var _2=$("photo_view_arrow_prev_small");
var _3=$("photo_view_arrow_next_small");
var _4=$("photo_view_arrow_caption_small");
var _5=this;
if((_1.keyNum==Keyboard.KEY_LEFT)&&(_2.className.indexOf("hidden")==-1)){
this.setSelected(_2);
this.moveImage(-1);
APUtils.queForExecution(this,function(){
this.setSelected(_4);
},200);
return true;
}else{
if((_1.keyNum==Keyboard.KEY_RIGHT)&&(_3.className.indexOf("hidden")==-1)){
this.setSelected(_3);
this.moveImage(1);
APUtils.queForExecution(this,function(){
this.setSelected(_4);
},200);
return true;
}
}
if(_1.keyNum==Keyboard.KEY_DOWN){
return true;
}else{
return SlideShowPhotoView.base._processKeyEvent.call(this,_1);
}
};
SlideShowPhotoView.prototype.onActivatedSoftMenu=function(){
SlideShowPhotoView.base.onActivatedSoftMenu.call(this);
var _6=this;
var _7=window.menu;
var _8=this.addSoftMenuItem(StringTable.qtn_play,SlideShowPhotoView.PLAY);
_8.menuItem.onSelect=function(){
APUtils.queForExecution(_6,function(){
_6._playAction();
});
};
_7.append(_8.menuItem);
var _9=this.addSoftMenuItem(StringTable.qtn_stop,SlideShowPhotoView.STOP);
_9.menuItem.onSelect=function(){
APUtils.queForExecution(_6,function(){
_6._stopAction();
});
};
_7.append(_9.menuItem);
var _a=this.addSoftMenuItem(StringTable.qtn_share,SlideShowPhotoView.SHARE);
_a.menuItem.onSelect=function(){
APUtils.queForExecution(_6,function(){
_6._showShare();
});
};
_7.append(_a.menuItem);
var _b=this.addSoftMenuItem(StringTable.qtn_caption,SlideShowPhotoView.CAPTION);
_b.menuItem.onSelect=function(){
APUtils.queForExecution(_6,function(){
_6._showCaption();
});
};
_7.append(_b.menuItem);
var _c=this.addSoftMenuItem(StringTable.qtn_next,SlideShowPhotoView.NEXT);
_c.menuItem.onSelect=function(){
APUtils.queForExecution(_6,function(){
_6.moveImage(1);
});
};
_7.append(_c.menuItem);
var _d=this.addSoftMenuItem(StringTable.qtn_prev,SlideShowPhotoView.PREV);
_d.menuItem.onSelect=function(){
APUtils.queForExecution(_6,function(){
_6.moveImage(-1);
});
};
_7.append(_d.menuItem);
};
SlideShowPhotoView.prototype.setButtonsForTouch=function(){
var _e=this;
this.playBtn=$($("photo_view_play"));
this.playBtnLandscape=$($("photo_view_play_landscape"));
Events(this.playBtn).setAction(function(){
_e.mode(!_e._mode);
});
Events(this.playBtnLandscape).setAction(function(){
_e.mode(!_e._mode);
});
var _f=$("photo_view_arrow_prev");
var _10=$("photo_view_arrow_prev_landscape");
Events(_f).setAction(function(){
_e.moveImage(-1);
});
Events(_10).setAction(function(){
_e.moveImage(-1);
});
var _11=$("photo_view_arrow_next");
var _12=$("photo_view_arrow_next_landscape");
Events(_11).setAction(function(){
_e.moveImage(1);
});
Events(_12).setAction(function(){
_e.moveImage(1);
});
var _13=$("photo_view_share");
var _14=$("photo_view_share_landscape");
Events(_13).setAction(function(){
_e._showShare();
});
Events(_14).setAction(function(){
_e._showShare();
});
var _15=$("photo_view_caption_buttun");
var _16=$("photo_view_caption_buttun_landscape");
Events(_15).setAction(function(){
_e._showCaption();
});
Events(_16).setAction(function(){
_e._showCaption();
});
};
SlideShowPhotoView.prototype.setButtonsForNonTouch=function(){
var _17=this;
var _18=$("photo_view_arrow_caption_small");
Events(_18).setAction(function(){
_17._showCaption();
});
this.invalidate();
this.setSelected(_18);
};
SlideShowPhotoView.prototype.onDeactivated=function(){
SlideShowPhotoView.base.onDeactivated.call(this);
clearTimeout(this._backgroundId);
clearTimeout(this.__transitionId);
this._stopSlideCaption();
delete this._backgroundId;
delete this.__transitionId;
delete this._imagesList;
var el=$("long_images");
el.scrollLeft=0;
for(var x=0;x<el.childNodes.length;x++){
el.childNodes[x].childNodes[0].src="foo";
el.childNodes[x].childNodes[1].src="foo";
}
el.removeChildren();
};
SlideShowPhotoView.prototype.onResize=function(){
if(this.isActive()){
var _1b=$("long_images");
_1b.style.height=this._getImageSize().height;
_1b.style.width=this.getCurrentScrollPos();
var _1c=Math.round(this._getImageSize().height/2);
for(var _1d=0;_1d<_1b.childNodes.length;_1d++){
_1b.childNodes[_1d].childNodes[0].style.marginTop=_1c+"px";
this._resizeImage(_1b.childNodes[_1d].childNodes[1]);
}
container=$("photo_view_container");
this._scrollLeftDes=this._getScrollxDes();
container.scrollLeft=this._scrollLeftDes;
}
};
SlideShowPhotoView.prototype.getCurrentScrollPos=function(){
return (this._imagesLength*(this._getImageSize().width+20));
};
SlideShowPhotoView.prototype.displayImagesList=function(_1e,_1f,_20,_21,_22){
if(!_22){
_22=false;
}
this._reporting=_22;
this._imageLoaded=false;
if(_21===undefined){
_21=0;
}
this._caption=false;
this.setBackPage(_1e);
this.parent.activate(this.id);
this._imagesList=_1f;
this._currentIndex=_21-1;
this._startIndex=_21;
this._imagesLength=0;
$("photo_view_caption").show(false);
this.mode(true,true);
};
SlideShowPhotoView.prototype.mode=function(_23,_24){
var el=$("photo_view_play");
var _26=$("photo_view_play_landscape");
this._mode=_23;
if(_23){
if(WrtHelper.isTouchEnabledDevice()){
el.className="button";
el.innerHTML=StringTable.qtn_play;
_26.className="button";
_26.innerHTML=StringTable.qtn_play;
}else{
APUtils.queForExecution(this,function(){
this.getMenuItemById(SlideShowPhotoView.PLAY).setMyDimmed(false);
this.getMenuItemById(SlideShowPhotoView.STOP).setMyDimmed(true);
this._setRightSoftKey();
});
}
if(_24){
this.autoSlide();
}
clearTimeout(this._backgroundId);
}else{
if(this._currentIndex==this._imagesList.length-1){
return;
}
this._playNextSlide();
if(this._imagesList.length===1){
return;
}
if(WrtHelper.isTouchEnabledDevice()){
el.className="button red";
el.innerHTML=StringTable.qtn_stop;
_26.className="button red";
_26.innerHTML=StringTable.qtn_stop;
}else{
this.getMenuItemById(SlideShowPhotoView.PLAY).setMyDimmed(true);
this.getMenuItemById(SlideShowPhotoView.STOP).setMyDimmed(false);
}
}
};
SlideShowPhotoView.prototype.moveImage=function(_27){
if(!this._mode){
this.mode(true);
if(!WrtHelper.isTouchEnabledDevice()){
this._setRightSoftKey();
}
}
this._diraction=_27;
var i=this._currentIndex+_27;
if(i<0||i>this._imagesList.length-1){
this._setRightSoftKey();
return;
}
this._currentIndex=i;
this.moveFor();
};
SlideShowPhotoView.prototype.autoSlide=function(){
var i=this._currentIndex;
i++;
if(i<0||i>this._imagesList.length-1){
return;
}
this._currentIndex=i;
if(this._currentIndex==this._imagesList.length-1){
this.mode(true);
}
this._diraction=1;
this.moveFor();
};
SlideShowPhotoView.prototype._arrowNextShow=function(_2a){
if(WrtHelper.isTouchEnabledDevice()){
$("photo_view_arrow_next").show(_2a);
$("photo_view_arrow_next_landscape").show(_2a);
}else{
APUtils.queForExecution(this,function(){
this.getMenuItemById(SlideShowPhotoView.NEXT).setMyDimmed(!_2a);
$("photo_view_arrow_next_small").show(_2a);
});
}
this.invalidate();
};
SlideShowPhotoView.prototype._arrowPrevShow=function(_2b){
if(WrtHelper.isTouchEnabledDevice()){
$("photo_view_arrow_prev").show(_2b);
$("photo_view_arrow_prev_landscape").show(_2b);
}else{
APUtils.queForExecution(this,function(){
this.getMenuItemById(SlideShowPhotoView.PREV).setMyDimmed(!_2b);
$("photo_view_arrow_prev_small").show(_2b);
});
}
this.invalidate();
};
SlideShowPhotoView.prototype._setVisibleArrows=function(){
if(this._imagesList.length===1){
this._arrowPrevShow(false);
this._arrowNextShow(false);
return;
}
if(this._currentIndex===0){
this._arrowPrevShow(false);
this._arrowNextShow(true);
}else{
if(this._currentIndex==this._imagesList.length-1){
this._arrowPrevShow(true);
this._arrowNextShow(false);
}else{
this._arrowPrevShow(true);
this._arrowNextShow(true);
}
}
};
SlideShowPhotoView.prototype.moveFor=function(_2c){
if(this._imagesList.length-1<this._currentIndex){
return;
}
this._setVisibleArrows();
var _2d=this._imagesList[this._currentIndex].getText();
if(!_2d||_2d.constructor===Array){
_2d=this._imagesList[this._currentIndex].getStory().getDescription();
}
this._setCaption(_2d);
_2d=null;
$("photo_view_pagination").innerHTML=Utils.format(StringTable.qtn_pagination,this._currentIndex+1,this._imagesList.length);
this._startSlideCaption();
this._slideReachDes=false;
this._insertHtmlImage();
this._scrollLeftDes=this._getScrollxDes();
this._transition();
};
SlideShowPhotoView.prototype._getScrollxDes=function(){
var x=this._currentIndex-this._startIndex;
return (this._getImageSize().width*x)+(x*20)+20;
};
SlideShowPhotoView.prototype._transition=function(){
var _2f=$("photo_view_container").scrollLeft;
if(_2f==this._scrollLeftDes){
var dir=this._diraction*-2;
var img=$("imageSlide"+(this._currentIndex+dir));
if(img){
img.childNodes[1].onerrortmp=img.childNodes[1].onerror;
img.childNodes[1].onerror=null;
img.childNodes[1].src="foo";
}
this._slideReachDes=true;
this._playNextSlide();
return;
}
var _32=$("photo_view_container");
if(_32.scrollLeft<this._scrollLeftDes){
_32.scrollLeft+=WrtHelper.isLargeScreen()?SlideShowPhotoView.CHANGE_POSTION:SlideShowPhotoView.CHANGE_POSTION_SMALL;
if(_32.scrollLeft>this._scrollLeftDes){
_32.scrollLeft=this._scrollLeftDes;
}
}else{
_32.scrollLeft-=WrtHelper.isLargeScreen()?SlideShowPhotoView.CHANGE_POSTION:SlideShowPhotoView.CHANGE_POSTION_SMALL;
if(_32.scrollLeft<this._scrollLeftDes){
_32.scrollLeft=this._scrollLeftDes;
}
}
var _33=this;
var _34=WrtHelper.isLargeScreen()?SlideShowPhotoView.CHANGE_POSTION_INTERVAL:SlideShowPhotoView.CHANGE_POSTION_INTERVAL_SMALL;
this.__transitionId=setTimeout(function(){
_33._transition();
},_34);
};
SlideShowPhotoView.prototype._insertHtmlImage=function(){
var dir;
var _36;
if(this._diraction<0){
dir=this._diraction;
_36=this._currentIndex+dir;
}else{
dir=this._diraction;
_36=this._currentIndex+dir;
}
var img=$("imageSlide"+_36);
if(img!=null){
$(img.childNodes[1]).show(false);
$(img.childNodes[0]).show(true);
img.childNodes[1].onerror=img.childNodes[1].onerrortmp;
img.childNodes[1].src=this._imagesList[_36].getImageUrl(540,540,false);
}
if($("imageSlide"+this._currentIndex)!=null){
return;
}
this._imagesLength++;
var div=$("long_images");
var _39=document.createElement("div");
_39.id="imageSlide"+this._currentIndex;
if(WrtHelper.isLargeScreen()){
this._getHtmlImageForTouch(_39,this._imagesList[this._currentIndex]);
}else{
this._getHtmlImageForNonTouch(_39,this._imagesList[this._currentIndex]);
}
if(this._startIndex>this._currentIndex){
div.insertBefore(_39,$("imageSlide"+this._startIndex));
$("photo_view_container").scrollLeft=this._getImageSize().width+20;
this._startIndex=this._currentIndex;
}else{
div.appendChild(_39);
}
div.style.height=this._getImageSize().height+"px";
var _3a=this.getCurrentScrollPos();
div.style.width=_3a+"px";
return _3a;
};
SlideShowPhotoView.prototype._getHtmlImageForNonTouch=function(div,_3c){
div.className="imageSlide";
var _3d=document.createElement("img");
_3d.src="./images/loader.gif?time="+new Date().getTime();
_3d.style.marginTop=this._getImageSize().height/2+"px";
div.appendChild(_3d);
var _3e=document.createElement("div");
div.appendChild(_3e);
_3e.id="container_image_"+this._currentIndex;
_3e.style.overflow="hidden";
_3e.style.height="1px";
_3e.style.width="1px";
var _3f=document.createElement("img");
_3f._index=this._currentIndex;
this._loadedImage=false;
var _40=this;
this._imageLoaded=false;
_3e.appendChild(_3f);
var _41=setTimeout(function(){
_3f.height=200;
_3f.width=200;
_3f.src="images/offline_photo_view.png";
},8000);
_3f.onload=function(){
_3f.onload=null;
clearTimeout(_41);
this._defaultHeight=this.height;
this._defaultWidth=this.width;
var _42=$("container_image_"+this._index);
_42.style.width=null;
_42.style.height=null;
_42.style.overflow=null;
var div=$("imageSlide"+this._index);
div.removeChild(_42);
div.appendChild(this);
_40._resizeImage(this);
$(_3d).show(false);
_40._imageLoaded=true;
_40._playNextSlide();
};
_3f.src=new String(_3c.getImageUrl(320,320,false));
};
SlideShowPhotoView.prototype._getHtmlImageForTouch=function(div,_45){
div.className="imageSlide";
var _46=document.createElement("img");
_46.src="./images/loader.gif";
_46.style.marginTop=this._getImageSize().height/2+"px";
div.appendChild(_46);
var _47=document.createElement("img");
_47.className="hidden";
this._loadedImage=false;
var _48=this;
this._imageLoaded=false;
_47.onload=function(){
this._defaultHeight=this.naturalHeight;
this._defaultWidth=this.naturalWidth;
_48._resizeImage(this);
$(_46).show(false);
_48._imageLoaded=true;
_48._playNextSlide();
};
_47.onerror=function(){
this.height=200;
this.width=200;
this.src="images/offline_photo_view.png";
};
_47.src=_45.getImageUrl(540,540,false);
div.appendChild(_47);
};
SlideShowPhotoView.prototype._resizeImage=function(img,_4a){
img.height=img._defaultHeight;
img.width=img._defaultWidth;
var _4b=$("imageSlide"+(_4a===undefined?this._currentIndex:_4a));
if(img&&_4b){
var _4c=Utils.resizeImage(img,_4b);
var _4d=(_4b.clientHeight-_4c.height)/2;
img.style.marginTop=_4d+"px";
img.width=_4c.width;
img.height=_4c.height;
img.className="";
}
};
SlideShowPhotoView.prototype._playNextSlide=function(){
var _4e=this;
if(this._slideReachDes&&this._imageLoaded&&!this._mode){
this._backgroundId=setTimeout(function(){
_4e.autoSlide();
},SlideShowPhotoView.DELAY_IMAGE);
}else{
return;
}
};
SlideShowPhotoView.prototype._getImageSize=function(){
var el=$("photo_view_container");
return {width:el.offsetWidth,height:el.offsetHeight};
};
SlideShowPhotoView.prototype._playAction=function(){
var _50=this;
this.mode(!this._mode);
window.menu.setRightSoftkeyLabel(StringTable.qtn_stop,function(){
_50._stopAction();
});
};
SlideShowPhotoView.prototype._stopAction=function(){
this.mode(!this._mode);
this._setRightSoftKey();
};
SlideShowPhotoView.prototype._showShare=function(){
this.mode(true);
APUtils.queForExecution(this,function(){
new PhotoPopup(this,this._imagesList[this._currentIndex],true).show();
});
};
SlideShowPhotoView.prototype._showCaption=function(){
if(this._caption){
$("photo_view_caption").show(false);
this._stopSlideCaption();
}else{
$("photo_view_caption").show(true);
this._startSlideCaption();
}
this._caption=!this._caption;
};
SlideShowPhotoView.prototype._setCaption=function(_51){
this._stopSlideCaption();
$("photo_view_caption").innerHTML=new String(_51)+"<br/>";
this._startSlideCaption();
};
SlideShowPhotoView.prototype._stopSlideCaption=function(){
if(this._bgInterval){
var _52=$("photo_view_caption");
clearInterval(this._bgInterval);
_52.endOfLine=false;
_52.style.height="";
delete this._bgInterval;
}
};
SlideShowPhotoView.prototype._startSlideCaption=function(){
var _53=$("photo_view_caption");
var _54=Math.round($("long_images").clientHeight/3);
if(_53.clientHeight>_54&&_53.className.indexOf("hidden")==-1){
this._stopSlideCaption();
_53.style.height=_54+"px";
_53.style.overflow="hidden";
this._bgInterval=setInterval(function(){
if(!_53.endOfLine){
_53.scrollTop+=2;
if(_53.scrollTop+_53.offsetHeight>=_53.scrollHeight){
_53.endOfLine=true;
setTimeout(function(){
_53.endOfLine=false;
_53.scrollTop=0;
},2000);
}
}
},140);
}
};
SlideShowPhotoView.CHANGE_POSTION=70;
SlideShowPhotoView.CHANGE_POSTION_SMALL=25;
SlideShowPhotoView.CHANGE_POSTION_INTERVAL=10;
SlideShowPhotoView.CHANGE_POSTION_SMALL=10;
SlideShowPhotoView.DELAY_IMAGE=3000;
SlideShowPhotoView.PLAY=3001;
SlideShowPhotoView.STOP=3002;
SlideShowPhotoView.SHARE=3003;
SlideShowPhotoView.CAPTION=3004;
SlideShowPhotoView.NEXT=3005;
SlideShowPhotoView.PREV=3006;
