function AbstractTimer(){
this.id=null;
this.handler=null;
this.isProcessing=false;
};
AbstractTimer.prototype.start=function(_1){
if(this.id!=null){
if(AbstractTimer.log.isDebugEnabled()){
AbstractTimer.log.debug("Timer already running");
}
return;
}
var _2=this;
function tick(){
_2._tick();
};
this.id=this._start(tick,_1);
};
AbstractTimer.prototype.stop=function(){
if(this.id==null){
if(AbstractTimer.log.isDebugEnabled()){
AbstractTimer.log.debug("Timer is not running");
}
return;
}
this._stop(this.id);
this.id=null;
};
AbstractTimer.prototype._tick=function(){
if(this.isProcessing){
if(AbstractTimer.log.isDebugEnabled()){
AbstractTimer.log.debug("Ignoring tick, already processing...");
}
return;
}
this.isProcessing=true;
try{
if(this.handler){
this.handler.call(this);
}
}
finally{
this.isProcessing=false;
}
};
AbstractTimer.log=Logger.getLogger("AbstractTimer");
function Timer(){
};
Helper.extend(Timer,AbstractTimer);
Timer.prototype._start=function(_3,_4){
return setTimeout(_3,_4);
};
Timer.prototype._stop=function(id){
clearTimeout(id);
};
function IntervalTimer(){
};
Helper.extend(IntervalTimer,AbstractTimer);
IntervalTimer.prototype._start=function(_6,_7){
return setInterval(_6,_7);
};
IntervalTimer.prototype._stop=function(id){
clearInterval(id);
};
